﻿using System;
using System.Windows;
using System.Windows.Interactivity;

namespace SharpGIS.Silverlight.Behaviors
{
	public class HideOnInstall : Behavior<UIElement>
	{
		/// <summary>
		/// Called after the behavior is attached to an AssociatedObject.
		/// </summary>
		/// <remarks>Override this to hook up functionality to the AssociatedObject.</remarks>
		protected override void OnAttached()
		{
			base.OnAttached();
			if (Application.Current.InstallState == InstallState.Installed)
				this.AssociatedObject.Visibility = Visibility.Collapsed;
			Application.Current.InstallStateChanged += Current_InstallStateChanged;
		}

		protected override void OnDetaching()
		{
			base.OnDetaching();
			Application.Current.InstallStateChanged -= Current_InstallStateChanged;
		}

		private void Current_InstallStateChanged(object sender, EventArgs e)
		{
			this.AssociatedObject.Visibility = (Application.Current.InstallState == InstallState.Installed)
				? Visibility.Collapsed : Visibility.Visible;
		}
	}
}
